import { sendInteractionResponse, SlashCommandOptions } from "@wackford/mod.ts";
import { AIs, checkAI } from "../ai/index.ts";

export default {
    name: "status",
    description: "shows the current name and description of the chatbot",
    execute: async (bot, interaction) => {
        const AI = AIs[interaction?.channelId?.toString() as string];

        if (!checkAI(bot, interaction, AI)) return;

        await sendInteractionResponse(bot, interaction, {
            content: `Name: ${AI.name}\nDescription: ${AI.description}\nAI: ${AI.constructor.name}`,
        });
    },
} as SlashCommandOptions;
